module Death

=begin

 player.lifeprot?ξ硢ץ쥤䡼ϻǤޤ
 ʲξˤϡޤ

  fell into a bottomless pit           # ʤܡ
  killed his family and killed himself # ̼˴²˴ץ쥤䡼˴
  fell through a bottomless trap door  # ʤꡣ

=end

  def resuscitate( client )

    player = client.player
    mesg   = player.mesg
    
    # ߤ롣
    if ( player.killed? ) && ( player.lifeprot? )
      message( client, mesg[ 1282 ] )
      player.resuscitated
    end
    
  end
  
  def death_routine( client, damage, string )

    player = client.player
    
    player.losehp( damage ) # ᡼äơ
    resuscitate( client )   # ⤷ߤ롣
    
    # ¸档³ԡ
    return unless player.killed?
    
    # ˴Τǡ󥭥󥰤Ͽ
    client.killed
    ranking_for_loser( client, player.score, $HARDGAME, client.name, string )
    # morgue( client )

    exit
        
  end

  def ranking_for_loser( client, *score_arg )

    mesg = client.player.mesg
    
    @database.ranking_for_loser( *score_arg )

    # 她ԡԼԤ8ͤġ
    client.ranking_latest( mesg[ 1866 ], score_arg )
    client.ranking_winner( mesg[ 1862 ], mesg[ 1863 ],
			  @database.winners_best( 8 ), mesg[ 1868 ] )
    client.ranking_loser( mesg[ 1864 ], mesg[ 1865 ],
			 @database.losers_best( 8 ), mesg[ 1868 ],
			 score_arg[ 0 ] )

  end
  
  # score, hardgame, mobuls, name, string
  
  def ranking_for_winner( client, *score_arg )

    mesg = client.player.mesg

    @database.ranking_for_winner( *( score_arg[ 0 .. -2 ] ) )

    latest = score_arg.dup
    latest[ 2 ] = nil
    latest.delete( nil )
    
    client.ranking_latest( mesg[ 1866 ], latest )
    client.ranking_winner( mesg[ 1862 ], mesg[ 1863 ],
			  @database.winners_best( 8 ), mesg[ 1868 ],
			  score_arg[ 0 ] )
    client.ranking_loser( mesg[ 1864 ], mesg[ 1865 ],
			 @database.losers_best( 8 ), mesg[ 1868 ] )
    
  end



  
  def death_quit( client )
    exit
  end

  def death_suspended( client )
    exit
  end

  # ǤϤʤΤˡLifeprotǤΤԻ׵ġ
  
  def death_self_annihilated( client )

    ( player = client.player ).annihilated
    # 1252 "self - annihilated"
    death_routine( client, 0, player.mesg[ 1252 ] )
    
  end


  def death_arrow( client, damage )
    death_routine( client, damage, client.player.mesg[ 1253 ] )
  end

  def death_dart( client, damage )
    death_routine( client, damage, client.player.mesg[ 1254 ] )
  end

  def death_pit( client, damage )
    death_routine( client, damage, client.player.mesg[ 1255 ] )
  end

  def death_bottomless_pit( client )

    ( player = client.player ).bottomless_pit
    client.killed
    ranking_for_loser( client, player.score, $HARDGAME, client.name,
		      player.mesg[ 1256 ] )
    exit
    
  end

  def charge_for_winner( client )
    @database.charge( client.name, client.player.score2tax )
  end

  def win_mail( client )

    player = client.player
    mesg   = player.mesg
    
    # ᡼6̡
    # ᡼1̤ˤϡ%d( player.all_gold )%d( player.score2tax )
    # ޤޤޤա

    # 1ܡ
    
    mail = mesg[ 1880, 24 ]
    mail.delete( nil )
    
    gold = false
    mail.collect! do | string |

      if string =~ /%d/ 
	string = sprintf( string, !gold ? player.all_gold : player.score2tax )
	gold = true
      end

      string
      
    end
    
    client.mail( mail )

    # 2ܤ顢6ܤޤǡ

    5.times do | i |
      mail = mesg[ 1910 + 30 * i, 24 ]
      mail.delete( nil )
      client.mail( mail )
    end

  end
  
  def winner( client )

    player = client.player

    charge_for_winner( client )
    @database.win( client.name, $HARDGAME )
    
    win_mail( client )
    
    ranking_for_winner( client, player.score, $HARDGAME,
		       player.mobuls_elapsed, client.name, player.mesg[ 1257 ] )
    # morgue( client )
    exit
    
  end

  def death_solid_rock( client )
    
    # 1258 "trapped in solid rock"
    ( player = client.player ).solid_rock
    death_routine( client, 0, player.mesg[ 1258 ] )
    
  end

  def death_missing_save_file( client )

  end

  def death_old_save_file( client )

  end

  def death_cheater_checker_trap( client )

  end
  
  def death_protected_save_file( client )

  end

  def death_kill_his_family( client )
    
    # 1263 "killed his family and committed suicide"
    ( player = client.player ).suicide
    ranking_for_loser( client, player.score, $HARDGAME, client.name,
		      player.mesg[ 1263 ] )

    # morgue( client )

    exit
    
  end
  
  def death_wayward_finger( client )

    ( player = client.player ).wayward_finger
    # 1264 "erased by a wayward finger"
    death_routine( client, 0, player.mesg[ 1264 ] )
    
  end

  def death_fell_through_bottomless( client )
    
    # 1265 "fell through a bottomless trap door"
    ( player = client.player ).bottomless_trap_door
    client.killed
    ranking_for_loser( client, player.score, $HARDGAME, client.name,
		      player.mesg[ 1265 ] )
    # morgue( client )

    exit
    
  end

  def death_fell_throught_door( client, damage )
    death_routine( client, damage, client.player.mesg[ 1266 ] )
  end

  def death_drank_poison( client, damage )
    death_routine( client, damage, client.player.mesg[ 1267 ] )
  end
  
  def death_electric_shock( client, damage )
    # 1268 "fried by an electric shock"
    death_routine( client, damage, client.player.mesg[ 1268 ] )
  end

  def death_slipped_shaft( client, damage )
    # 1269 "slipped on a volcano shaft"
    death_routine( client, damage, client.player.mesg[ 1269 ] )
  end

  def death_stupid_frustration( client, damage )
    # 1270 "killed by a stupid act of frustration"
    death_routine( client, damage, client.player.mesg[ 1270 ] )
  end

  def death_revolting_demon( client, damage )
    # 1271 "attacked by a revolting demon",
    death_routine( client, damage, client.player.mesg[ 1271 ] )
  end

  def death_own_magic( client, damage )
    # 1272 "hit by his own magic"
    death_routine( client, damage, client.player.mesg[ 1272 ] )
  end
  
  def death_demolished( client, damage )
    # 1273 "demolished by an unseen attacker",
    
  end

  def death_monster_attack( client, monster, damage )

    player = client.player
    mesg   = player.mesg
    
    player.hit_damaged( damage )
    resuscitate( client )   # ⤷ߤ롣
    
    # ¸档³ԡ
    return unless player.killed?
    
    # ˴Τǡ󥭥󥰤Ͽ

    client.killed
    ranking_for_loser( client, player.score, $HARDGAME, client.name,
		      player.blindcount? ? mesg[ 1273 ] :
		      killed_string( player, monster ) )
    
    # morgue( client )

    exit
    
  end

  def killed_string( player, monster )
    sprintf( player.mesg[ 1281 ], player.monstername( monster ),
	    player.caveclass( @level ) )  
  end
  
  def death_dreadful_sleep( client )
    
    ( player = client.player ).dreadful_sleep
    # 1274 "fell into the dreadful sleep"
    death_routine( client, 0, player.mesg[ 1274 ] )

  end


  def death_exploding_chest( client, damage )
    # 1275 "killed by an exploding chest"
    death_routine( client, damage, client.player.mesg[ 1275 ] )
  end

  
  def death_missing_maze_file( client )

  end

  def death_sphere_of_annihilation( client )
    ( player = client.player ).annihilated
    # 1277 "annihilated in a sphere"
    death_routine( client, 0, player.mesg[ 1277 ] )
  end

  def death_post_mortem_death( client )

  end


  def death_quick_quit( client )

  end

  
end
